// X25519
// aka ECDH on Curve25519 from [RFC7748](https://www.rfc-editor.org/rfc/rfc7748)

export function genKeys() {
    const priv = nobleCurves.x25519.utils.randomPrivateKey();
    const pub = nobleCurves.x25519.getPublicKey(priv);
    return {
        privkey: priv,
        pubkey: pub
    };
}

export function sharedKey(priv, pub) {
    return nobleCurves.x25519.getSharedSecret(priv, pub);
}
