const express = require("express");
const accountController = require("../controllers/account");
const router = express.Router();

router
  .route("/register")
  .post(accountController.register);

router
  .route("/login")
  .get(accountController.loginGetChallenge);

router
  .route("/logout")
  .get(accountController.logout);

router
  .route("/verify-challenge")
  .post(accountController.loginVerifyChallenge);

router
  .route("/get-public-key")
  .get(accountController.getPublicKey);

module.exports = router;
